/**
 * 汇付天下有限公司
 * Copyright (c) 2006-2021 ChinaPnR,Inc.All Rights Reserved.
 */
package com.huifu.bspay.sdk.demo.trans;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.huifu.bspay.sdk.core.utils.HttpClientUtils;

import java.util.Calendar;

/**
 *
 * @author kefeng.zheng
 * @version v 0.1
 */
public class SchemeCodeTest {

    private String URL= "https://api.weixin.qq.com/wxa/generatescheme";

    private String GET_ACCESS_TOKEN_URL= "https://api.weixin.qq.com/cgi-bin/token";

    @org.junit.Test
    public void testSchemeCode() {
        Calendar cl = Calendar.getInstance();
        cl.add(Calendar.MINUTE, 5);

        // 获取小程序ACCESS_TOKEN
        String accessToken = getMiniAppAccessToken();
        System.out.println("accessToken=" + accessToken);
        String url = URL + "?access_token=" + accessToken;
        try {
            JSONObject data = new JSONObject();
            JSONObject jumpWxa = new JSONObject();
            jumpWxa.put("path", "/pages/autopay/autopay");
            jumpWxa.put("query", "pay_amt=0.01&pre_seq_id=1234567890");
            data.put("jump_wxa", jumpWxa);
            data.put("is_expire", true);
            data.put("expire_time", cl.getTimeInMillis());

            // 目前仅针对国内非个人主体的小程序开放 个人申请的无法调用成功
            String respStr = HttpClientUtils.httpPostJson(url, null, JSON.toJSONString(data));
            System.out.println(respStr);
        } catch (Exception ex) {
            ;
        }
    }


    private String getMiniAppAccessToken() {
        JSONObject params = new JSONObject();
        params.put("grant_type", "client_credential");
        params.put("appid", "wx7dc923282810409f");
        params.put("secret", "64afb60bef3a280cdaca982ac282aa78");
        String response = null;
        try {
            response = HttpClientUtils.httpGet(GET_ACCESS_TOKEN_URL, params);
        } catch (Exception ex) {

        }
        JSONObject respObj = JSON.parseObject(response);
        System.out.println("respObj=" + respObj);
        return (String)respObj.get("access_token");
    }
}
